/* Rexx program to test access to the class 'datergf.DateTimeRGF'

   Make sure that *this* directory is in your %CLASSPATH%, otherwise
   the program cannot find the Java "datergf"-package (subdirectory of this one)*/

.bsf~import("DateTimeRGF",   "datergf.DateTimeRGF")     /* import the Java class*/
.bsf~import("DateFormatRGF", "datergf.DateFormatRGF")   /* import the Java class*/

dt1 = .DateTimeRGF~new                  /* create and get a DateTimeRGF object  */
say dt1~toString                        /* show its value                       */

dt1~update                              /* set to now                           */
say dt1~toString                        /* show the values                      */
say

i=3
say "now sleeping for" i "seconds ..."
call sysSleep i                         /* sleep i seconds                      */
dt1~update                              /* set to now                           */
say dt1~toString                        /* show the values                      */

say
date1 = dt1~bsf.getFieldValue("date")   /* get DateRGF field                    */
say "date-portion:" date1~toString

                                        /* determine ISO-week, using a public static
                                           field of the interface "DTC"         */
week=date1~get("i", .bsf~getStaticValue("datergf.DTC", "WEEK") )
say "today falls into ISO-week #" week
say

time1 = dt1~bsf.getFieldValue("time")   /* get TimeRGF field                    */
say "time-portion:" time1~toString
say

easter = date1~easter("o", date1)       /* get Easter sunday for this year      */
week=easter~get("i", .bsf~getStaticValue("datergf.DTC", "WEEK") )
say "This year Easter sunday is:" easter~toString "which is ISO-week #" week
say

say "---"
say

say "This demos the Java class 'DateFormatRGF':"
say
say "   the format string being used is:"
say

formatString="'Today is:' [EEEE], d. [MMM] yyyy, 'day #:' D (g 'to go'), hh:mm:ss.SSS [a]"
say formatString
say

df = .dateFormatRGF~new         /* get an instance of the dateformatter */

say df~format("str", formatString, "obj", dt1)
say "   ---"
say "   (now localizing the names of the months and days as well as the 'am/pm')"
df~localize
say df~format("str", formatString, "obj", dt1)
say "   the default formatting now produces:" '[' || dt1~toString || ']'
say "---"
say
say "Please press enter to continue..."
parse pull answer

locales.1="ITALIAN"
locales.2="FRENCH"
locales.3="UK"
locales.4="US"
locales.5="JAPANESE"
locales.0=5     /* indicate # of elements in stem ("hash")      */

do i=1 to locales.0
   say "trying to get the" locales.i "Locale from Java ("i "of" locales.0") ..."
   df~localize("obj", .bsf~getStaticValue("java.util.Locale", locales.i))
   say df~format("str", formatString, "obj", dt1)
   say "   the default formatting now produces:" '[' || dt1~toString || ']'
   say "---"
end


say "More on the Java package 'datergf' can be found at:"
say
say "   http://nestroy.wi-inf.uni-essen.de/Forschung/rgf/datergf/"
say
say "or check the Internet starting with:"
say
say "   http://www.RexxLA.org"

::requires "BSF.cls"            -- get the direct Object Rexx BSF support

